<?php

i18n_merge('ms_bip') || i18n_merge('ms_bip', 'en_US');

$thisfile=basename(__FILE__, ".php");

register_plugin(
	$thisfile, 							//идентификатор плагина
	i18n_r('ms_bip/MODULNAME'), 		//Название плагина
	i18n_r('ms_bip/MODULVERSION'), 		//Версия плагина
	i18n_r('ms_bip/MODULAUTOR'),		//автор плагина
	'http://muststyle.ru/', 			//сайт автора
	i18n_r('ms_bip/MODULDESCRIPTION'), 	//краткое описание плагина
	'msadmin', 							//тип страницы – на какой из вкладок административной панели появится плагин
	'bip_function'  					//главная функция плагина (функция администрирования)
);

# Основная функция режима техобслуживания
function bip_function(){
	global $SITEURL;
	$file 			= GSDATAOTHERPATH.'bip-base.xml';
	$xmlfile 		= simplexml_load_file($file);
	$countSessions 	= '0';

	if (!file_exists($file)) {
  		file_put_contents(GSDATAOTHERPATH.'bip-base.xml','<?xml version="1.0" encoding="utf-8"?><sessions></sessions>');
	} else {
		# Добавление сессии
		if( isset( $_POST['sessionADD'] ) ) {
			$sessionIP 		= $_POST["inputIP"];
			$sessionDATES 	= date("d.m.y");
			$sessionDATE 	= $_POST["inputDATE"];
			$sessionMESS 	= $_POST["inputMESS"];
			
			$sessionIPCheck = count($xmlfile->xpath('/sessions/session[@ip="'.$sessionIP.'"]'));
			
			if ($sessionIPCheck < 1) {
				$dom = new DOMDocument; 
				$dom->load($file);
				$xpath = new DOMXPath($dom);
				
				$sessions=$xpath->query('/sessions')->item(0);
				$session = $dom->createElement('session');
				$attribute1 = $dom->createAttribute("ip");
				$attribute2 = $dom->createAttribute("dates");
				$attribute3 = $dom->createAttribute("date");
				$attribute4 = $dom->createAttribute("message");
				$attribute1->value = $sessionIP;
				$session->appendChild($attribute1);
				$attribute2->value = $sessionDATES;
				$session->appendChild($attribute2);
				$attribute3->value = $sessionDATE;
				$session->appendChild($attribute3);
				$attribute4->value = $sessionMESS;
				$session->appendChild($attribute4);
				$sessions->appendChild($session);
				$dom->save($file);
				}
			else
				{
					echo '
					<script>setTimeout("$(\'div.notice\').fadeOut(500);", 5000);</script>
					<div class="notice"><i class="fa fa-info-circle" aria-hidden="true"></i> ' . i18n_r('ms_bip/IPEXIST') . '</div>
					';
				}
		}
		
		# Удаление сессии
		if( isset( $_POST['sessionDEL'] ) ) {
			$dom = new DOMDocument; 
			$dom->load($file);
			$xpath = new DOMXPath($dom); 
			
			$ip = $_POST["sessionDelIP"];

			$sessions = $xpath->query('/sessions/session[@ip="'.$ip.'"]');
			$el = $sessions->item(0);
			$el->parentNode->removeChild($el);
			$dom->save($file); 
		}
		
		# Форма поиска и добавления IP
		if( isset( $_POST['searchIP'] ) ) {
			if( isset( $_POST["inputIP"] ) ) {
				$filterIP 	= $_POST["inputIP"];
			} else {
				$filterIP 	= '';
			}
			$dom = new DOMDocument;
			$dom->load($file);
			$xpath = new DOMXPath($dom);
			$sessions = $xpath->query('/sessions/session[@ip="'.$filterIP.'"]');
			$countSessions 	= count($xmlfile->xpath('/sessions/session[@ip="'.$filterIP.'"]'));
		} else {
			$dom = new DOMDocument;
			$dom->load($file);
			$xpath = new DOMXPath($dom);
			$sessions = $xpath->query('/sessions/session');
			$countSessions 	= count($xmlfile->xpath('/sessions/session'));
		}
		if( isset( $_POST['resetIP'] ) ) {
			$dom = new DOMDocument;
			$dom->load($file);
			$xpath = new DOMXPath($dom);
			$sessions = $xpath->query('/sessions/session');
			$countSessions 	= count($xmlfile->xpath('/sessions/session'));
		}
	}
	echo '
	<link href="'.$SITEURL.'plugins/ms_bip/template/css/bip_style.css" rel="stylesheet" media="all">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css">
	<h3>' . i18n_r('ms_bip/MODULNAME') . ' <span style="float:right;">' . i18n_r('ms_bip/COUNTERTXT') . ': ' . $countSessions . '</span></h3>
	<form method="POST" name="formIP">
		<table id="form_add">
			<tr>
				<td width="25%"><input style="width:90%;" type="text" class="text" name="inputIP" placeholder="' . i18n_r('ms_bip/FORMIP') . '" maxlength="15" required></td>
				<td width="50%"><input style="width:95%;" type="text" class="text" name="inputMESS" placeholder="' . i18n_r('ms_bip/FORMREASON') . '" maxlength="110"></td>
				<td width="15%"><input style="width:80%;" type="text" class="text" name="inputDATE" placeholder="' . i18n_r('ms_bip/FORMDATE') . '" maxlength="8"></td>
				<td width="5%"><button style="width:100%;" type="submit" name="searchIP" class="btn" title="' . i18n_r('ms_bip/TITLESEARSH') . '"><i class="fa fa-fw fa-search" aria-hidden="true"></i></button></td>
				<td width="5%"><button style="width:100%;" type="submit" name="sessionADD" class="btn btn-add" title="' . i18n_r('ms_bip/TITLEADD') . '"><i class="fa fa-fw fa-plus" aria-hidden="true"></i></button></td>
			</tr>
		</table>
	</form>';
	
	if (file_exists($file)) {
		# Список сессий
		echo '
		<table id="bip-table" class="table table-hover">
			<thead> 
				<tr>  
					<th width="15%">' . i18n_r('ms_bip/IPADDRESS') . '</th> 
					<th width="60%">' . i18n_r('ms_bip/REASON') . '</th> 
					<th width="10%" style="text-align:center;"><i class="fa fa-lock" aria-hidden="true"></i></th>
					<th width="10%" style="text-align:center;"><i class="fa fa-unlock" aria-hidden="true"></i></th> 
					<th width="5%"></th>
				</tr> 
			</thead> 
			<tbody>';
				foreach ($sessions as $session) {
					$listSessionIp 		= $session->getAttribute('ip');
					$listSessionDateS 	= $session->getAttribute('dates');
					$listSessionDate 	= $session->getAttribute('date');
					$listSessionMess 	= $session->getAttribute('message');
					echo '
					<tr>
						<td>' . $listSessionIp . '</td>
						<td>'; if($listSessionMess != ''){echo $listSessionMess;} else {echo i18n_r('ms_bip/LISTREASON');} echo '</td>
						<td>'; if($listSessionDateS != ''){echo $listSessionDateS;} else {echo i18n_r('ms_bip/LISTDATENONE');} echo '</td>
						<td>'; if($listSessionDate != ''){echo $listSessionDate;} else {echo i18n_r('ms_bip/LISTDATENONE');} echo '</td>
						<td>
							<form method="POST">
								<button class="btn btn-sm btn-link" type="submit" name="sessionDEL" onclick="return confirm(\'' . i18n_r('ms_bip/DELCONFIRM') . $listSessionIp . ' ?\')"><i class="fa fa-fw fa-times" aria-hidden="true"></i></button>
								<input type="text" class="hidden" name="sessionDelIP" value="' . $listSessionIp . '" />
							</form>
						</td>
					</tr>
					';
				}
			echo '
			</tbody>
		</table>';
		if( isset( $_POST['searchIP'] ) ) {
			echo '<button type="submit" onclick="formIP.submit();" name="resetIP" class="btn btn-reset">' . i18n_r('ms_bip/FORMRESET') . '</button>';
		}
		echo '
			<div id="pager" class="pager" style="height:20px;margin:0px 0px 5px;">
				<form method="POST">
					<div style="float:left;text-align:left;padding:0px;">
						<i class="fa fa-fw fa-angle-double-left first" aria-hidden="true"></i>
						<i class="fa fa-fw fa-angle-left prev" aria-hidden="true"></i>
						<!-- the "pagedisplay" can be any element, including an input -->
						<span class="pagedisplay"></span>
						<i class="fa fa-fw fa-angle-right next" aria-hidden="true"></i>
						<i class="fa fa-fw fa-angle-double-right last" aria-hidden="true"></i>
					</div>
					<div style="float:right;text-align:right;padding:0px;">
						<span class="hidden-xs">' . i18n_r('ms_bip/PAGERTXT1') . '</span>
						<select class="pagesize">
							<option value="10" selected>' . i18n_r('ms_bip/PAGERTXT2') . '10</option>
							<option value="20">' . i18n_r('ms_bip/PAGERTXT2') . '20</option>
							<option value="30">' . i18n_r('ms_bip/PAGERTXT2') . '30</option>
							<option value="50">' . i18n_r('ms_bip/PAGERTXT2') . '50</option>
							<option value="all">' . i18n_r('ms_bip/PAGERTXT3') . '</option>
						</select>
					</div>
				</form>
			</div>
		';
		echo '
		<hr style="margin:30px 0px;border:none;border-top:1px solid #ddd;"/>
		<p>Если Вам понравился данный плагин и Вы хотели бы сказать нам спасибо:</p>
		<iframe src="https://money.yandex.ru/quickpay/shop-widget?writer=seller&targets=%D0%91%D0%BB%D0%B0%D0%B3%D0%BE%D0%B4%D0%B0%D1%80%D0%BD%D0%BE%D1%81%D1%82%D1%8C%20%D0%B7%D0%B0%20%D0%BF%D0%BE%D0%B4%D0%B4%D0%B5%D1%80%D0%B6%D0%BA%D1%83%20GetSimple&targets-hint=&default-sum=100&button-text=12&payment-type-choice=on&mobile-payment-type-choice=on&hint=&successURL=&quickpay=shop&account=410012592361672" width="450" height="213" frameborder="0" allowtransparency="true" scrolling="no"></iframe>
		<br/>
		<p style="margin-top:20px;">Плагин разработан студией дизайна MUST-STYLE - г. Санкт-Петербург<br/>Веб-сайт: <a href="http://muststyle.ru" target="_blank">http://muststyle.ru</a></p>
		<script type="text/javascript" src="'.$SITEURL.'plugins/ms_bip/template/js/jquery.tablesorter.js"></script>
		<script type="text/javascript" src="'.$SITEURL.'plugins/ms_bip/template/js/jquery.tablesorter.pager.js"></script>
		<script type="text/javascript" src="'.$SITEURL.'plugins/ms_bip/template/js/jquery.maskedinput.js"></script>
		<script type="text/javascript" src="'.$SITEURL.'plugins/ms_bip/template/js/bip_fx.js"></script>
		';
	}
}

# Добавляем ссылку на вкладку Темы 
add_action('msadmin-sidebar','createSideMenu',array($thisfile,i18n_r('ms_bip/MODULNAME')));
add_action('settings-sidebar','createSideMenu',array($thisfile,i18n_r('ms_bip/MODULNAME')));
add_action('index-pretemplate','bip_frontend');

# Формирование страницы-заглушки при включении режима техобслуживания
function bip_frontend() {
	global $SITEURL;
	$file 		= GSDATAOTHERPATH.'bip-base.xml';
	
	if (file_exists($file)) {
  		$xmlfile 	= simplexml_load_file($file);
		
		function PMA_getIpBIP() { 
			global $REMOTE_ADDR; 
			global $HTTP_X_FORWARDED_FOR, $HTTP_X_FORWARDED, $HTTP_FORWARDED_FOR, $HTTP_FORWARDED; 
			global $HTTP_VIA, $HTTP_X_COMING_FROM, $HTTP_COMING_FROM; 
		 
			// Get some server/environment variables values 
			if (empty($REMOTE_ADDR)) { 
				if (!empty($_SERVER) && isset($_SERVER['REMOTE_ADDR'])) { 
					$REMOTE_ADDR = $_SERVER['REMOTE_ADDR']; 
				} 
				else if (!empty($_ENV) && isset($_ENV['REMOTE_ADDR'])) { 
					$REMOTE_ADDR = $_ENV['REMOTE_ADDR']; 
				} 
				else if (@getenv('REMOTE_ADDR')) { 
					$REMOTE_ADDR = getenv('REMOTE_ADDR'); 
				} 
			} // end if 
			if (empty($HTTP_X_FORWARDED_FOR)) { 
				if (!empty($_SERVER) && isset($_SERVER['HTTP_X_FORWARDED_FOR'])) { 
					$HTTP_X_FORWARDED_FOR = $_SERVER['HTTP_X_FORWARDED_FOR']; 
				} 
				else if (!empty($_ENV) && isset($_ENV['HTTP_X_FORWARDED_FOR'])) { 
					$HTTP_X_FORWARDED_FOR = $_ENV['HTTP_X_FORWARDED_FOR']; 
				} 
				else if (@getenv('HTTP_X_FORWARDED_FOR')) { 
					$HTTP_X_FORWARDED_FOR = getenv('HTTP_X_FORWARDED_FOR'); 
				} 
			} // end if 
			if (empty($HTTP_X_FORWARDED)) { 
				if (!empty($_SERVER) && isset($_SERVER['HTTP_X_FORWARDED'])) { 
					$HTTP_X_FORWARDED = $_SERVER['HTTP_X_FORWARDED']; 
				} 
				else if (!empty($_ENV) && isset($_ENV['HTTP_X_FORWARDED'])) { 
					$HTTP_X_FORWARDED = $_ENV['HTTP_X_FORWARDED']; 
				} 
				else if (@getenv('HTTP_X_FORWARDED')) { 
					$HTTP_X_FORWARDED = getenv('HTTP_X_FORWARDED'); 
				} 
			} // end if 
			if (empty($HTTP_FORWARDED_FOR)) { 
				if (!empty($_SERVER) && isset($_SERVER['HTTP_FORWARDED_FOR'])) { 
					$HTTP_FORWARDED_FOR = $_SERVER['HTTP_FORWARDED_FOR']; 
				} 
				else if (!empty($_ENV) && isset($_ENV['HTTP_FORWARDED_FOR'])) { 
					$HTTP_FORWARDED_FOR = $_ENV['HTTP_FORWARDED_FOR']; 
				} 
				else if (@getenv('HTTP_FORWARDED_FOR')) { 
					$HTTP_FORWARDED_FOR = getenv('HTTP_FORWARDED_FOR'); 
				} 
			} // end if 
			if (empty($HTTP_FORWARDED)) { 
				if (!empty($_SERVER) && isset($_SERVER['HTTP_FORWARDED'])) { 
					$HTTP_FORWARDED = $_SERVER['HTTP_FORWARDED']; 
				} 
				else if (!empty($_ENV) && isset($_ENV['HTTP_FORWARDED'])) { 
					$HTTP_FORWARDED = $_ENV['HTTP_FORWARDED']; 
				} 
				else if (@getenv('HTTP_FORWARDED')) { 
					$HTTP_FORWARDED = getenv('HTTP_FORWARDED'); 
				} 
			} // end if 
			if (empty($HTTP_VIA)) { 
				if (!empty($_SERVER) && isset($_SERVER['HTTP_VIA'])) { 
					$HTTP_VIA = $_SERVER['HTTP_VIA']; 
				} 
				else if (!empty($_ENV) && isset($_ENV['HTTP_VIA'])) { 
					$HTTP_VIA = $_ENV['HTTP_VIA']; 
				} 
				else if (@getenv('HTTP_VIA')) { 
					$HTTP_VIA = getenv('HTTP_VIA'); 
				} 
			} // end if 
			if (empty($HTTP_X_COMING_FROM)) { 
				if (!empty($_SERVER) && isset($_SERVER['HTTP_X_COMING_FROM'])) { 
					$HTTP_X_COMING_FROM = $_SERVER['HTTP_X_COMING_FROM']; 
				} 
				else if (!empty($_ENV) && isset($_ENV['HTTP_X_COMING_FROM'])) { 
					$HTTP_X_COMING_FROM = $_ENV['HTTP_X_COMING_FROM']; 
				} 
				else if (@getenv('HTTP_X_COMING_FROM')) { 
					$HTTP_X_COMING_FROM = getenv('HTTP_X_COMING_FROM'); 
				} 
			} // end if 
			if (empty($HTTP_COMING_FROM)) { 
				if (!empty($_SERVER) && isset($_SERVER['HTTP_COMING_FROM'])) { 
					$HTTP_COMING_FROM = $_SERVER['HTTP_COMING_FROM']; 
				} 
				else if (!empty($_ENV) && isset($_ENV['HTTP_COMING_FROM'])) { 
					$HTTP_COMING_FROM = $_ENV['HTTP_COMING_FROM']; 
				} 
				else if (@getenv('HTTP_COMING_FROM')) { 
					$HTTP_COMING_FROM = getenv('HTTP_COMING_FROM'); 
				} 
			} // end if 
		 
			// Gets the default ip sent by the user 
			if (!empty($REMOTE_ADDR)) { 
				$direct_ip = $REMOTE_ADDR; 
			} 
		 
			// Gets the proxy ip sent by the user 
			$proxy_ip     = ''; 
			if (!empty($HTTP_X_FORWARDED_FOR)) { 
				$proxy_ip = $HTTP_X_FORWARDED_FOR; 
			} else if (!empty($HTTP_X_FORWARDED)) { 
				$proxy_ip = $HTTP_X_FORWARDED; 
			} else if (!empty($HTTP_FORWARDED_FOR)) { 
				$proxy_ip = $HTTP_FORWARDED_FOR; 
			} else if (!empty($HTTP_FORWARDED)) { 
				$proxy_ip = $HTTP_FORWARDED; 
			} else if (!empty($HTTP_VIA)) { 
				$proxy_ip = $HTTP_VIA; 
			} else if (!empty($HTTP_X_COMING_FROM)) { 
				$proxy_ip = $HTTP_X_COMING_FROM; 
			} else if (!empty($HTTP_COMING_FROM)) { 
				$proxy_ip = $HTTP_COMING_FROM; 
			} // end if... else if... 
		 
			// Returns the true IP if it has been found, else FALSE 
			if (empty($proxy_ip)) { 
				// True IP without proxy 
				return $direct_ip; 
			} else { 
				$is_ip = preg_match('|^([0-9]{1,3}\.){3,3}[0-9]{1,3}|', $proxy_ip, $regs); 
				if ($is_ip && (count($regs) > 0)) { 
					// True IP behind a proxy 
					return $regs[0]; 
				} else { 
					// Can't define IP: there is a proxy but we don't have 
					// information about the true IP 
					return FALSE; 
				} 
			} // end if... else... 
		} // end of the 'PMA_getIp()' function
		$sessionIP 	= PMA_getIpBIP();
		
		$userDate 		= date("d.m.y");
		$sessionCheck 	= count($xmlfile->xpath('/sessions/session[@ip="'.$sessionIP.'"]'));

		$dom = new DOMDocument;
		$dom->load($file);
		$xpath = new DOMXPath($dom);
		
		$sessions = $xpath->query('/sessions/session[@ip="'.$sessionIP.'"]');
		foreach ($sessions as $session) {
			$sessionMess 	= $session->getAttribute('message');
			$sessionDate 	= $session->getAttribute('date');
		}
		
		if ($sessionCheck > 0) {
			if( strtotime($userDate) < strtotime($sessionDate) || $sessionDate == '') {
				echo '	<!DOCTYPE>';
				echo '	<html>
							<head>
								<title>';
								get_site_name();
								echo '</title>
								<link href="'.$SITEURL.'plugins/ms_bip/template/css/bip_style_frontend.css" rel="stylesheet" media="all">
								<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
							</head>
							<body> 
								<div class="main_page">
									<div class="main_body_404">
										<div class="img_404"></div>
										<div class="text_404">
											<i>' . i18n_r('ms_bip/TMPLHEADER') . '</i><br/> ' . i18n_r('ms_bip/TMPLDESCRIPTION'); if($sessionDate != ''){echo i18n_r('ms_bip/TMPLDATEPRE') . $sessionDate;} if($sessionMess != ''){echo '<br/>' . $sessionMess;} else {echo '<br/>' . i18n_r('ms_bip/LISTREASON');} echo '<br/>
											<div style="margin-top:15px;"><a href="http://muststyle.ru" title="Студия дизайна MUST-STYLE - Создание эффективных сайтов в Санкт-Петербурге и всей России для малого и среднего бизнеса. +7 (812) 981-34-00">cоздание веб-сайтов</a> | <a href="https://goo.gl/5qFRuR" title="Интернет Хостинг Центр - надежный хостинг сайтов">php хостинг</a></div>
										</div>
									</div>
									<div class="clear"></div>
								</div>
							</body>
						</html>';
				die;
			} else {
				$dom = new DOMDocument; 
				$dom->load($file);
				$xpath = new DOMXPath($dom); 
				
				$ip = $_SERVER['REMOTE_ADDR'];

				$sessions = $xpath->query('/sessions/session[@ip="'.$ip.'"]');
				$el = $sessions->item(0);
				$el->parentNode->removeChild($el);
				$dom->save($file); 
			}
		}
	}
}
?>